package de.ullisroboterseite.ursai2keepalive;

import com.google.appinventor.components.annotations.*;

import android.app.*;
import android.content.*;

import android.os.IBinder;

import android.app.Notification.Builder;

import android.graphics.drawable.Icon;
import android.graphics.Bitmap;

import android.util.Log;
import de.ullisroboterseite.ursai2notification.UrsNotification;

@SimpleObject()
public class UrsService extends Service {
    static final String LOG_TAG = UrsAI2KeepAlive.LOG_TAG;

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.d(LOG_TAG, "UrsService: onStartCommand");

        // Falls FromChannel gesetzt ist, ist der Kanal bereits durch UrsAI2NotificationChanell angelegt worden.
        if (!intent.getBooleanExtra("FromChannel", false)) { // Channel muss angelegt werden
            Log.d(LOG_TAG, "Create Channel");
            Util.createNotificationChannel(this//
                    , intent.getStringExtra("ChannelID")//
                    , intent.getStringExtra("ChannelName")//
                    , intent.getStringExtra("ChannelDescription"));
        }

        Notification notification = null;
        int notificationID = UrsAI2KeepAlive.NotificationID;

        if (intent.getBooleanExtra("FromNotification", false)) {
            notification = UrsNotification.buildFromIntentExtras(this, intent);
            notificationID = intent.getIntExtra("NumberID", notificationID);
            Log.d(LOG_TAG, "Notification from object, ID: " + notificationID);


        } else {
            notification = Util.CerateNotification(this //
                    , intent.getStringExtra("ChannelID") //
                    , intent.getStringExtra("Title") //
                    , intent.getStringExtra("Text") //
                    , intent.getStringExtra("SmallIconPath") //
                    , intent.getIntExtra("Icon", 1) //
                    , intent.getStringExtra("ClassName")//
                    , intent.getStringExtra("StartValue"));
            Log.d(LOG_TAG, "Notification from keep alive");
        }


      //  Log.d(LOG_TAG, "----------- fields");
      //  Log.d(LOG_TAG, DebugUtil.spyFields(notification));


        startForeground(notificationID, notification);
        return START_NOT_STICKY;
    }

    @Override
    public void onDestroy() {
        Log.d(LOG_TAG, "UrsService: destroy");
        super.onDestroy();
    }

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

}