
package de.ullisroboterseite.ursai2keepalive;

import android.content.*;
import android.content.res.AssetManager;

import android.graphics.*;
import android.graphics.drawable.Icon;

import android.app.*;
import android.app.Notification.Builder;

import android.os.Environment;
import android.os.Build;

import android.util.Log;
import java.util.*;

import java.io.File;
import java.io.InputStream;
import java.io.IOException;
import java.lang.reflect.*;

class Util {
    static final String LOG_TAG = UrsAI2KeepAlive.LOG_TAG;

    static Map<String, Integer> IconIds = new HashMap<String, Integer>() {
        static final long serialVersionUID = 1L;
        {
            put("alert_dark_frame", 17301504); //
            put("alert_light_frame", 17301505); //
            put("arrow_down_float", 17301506); //
            put("arrow_up_float", 17301507); //
            put("bottom_bar", 17301658); //
            put("btn_default", 17301508); //
            put("btn_default_small", 17301509); //
            put("btn_dialog", 17301527); //
            put("btn_dropdown", 17301510); //
            put("btn_minus", 17301511); //
            put("btn_plus", 17301512); //
            put("btn_radio", 17301513); //
            put("btn_star", 17301514); //
            put("btn_star_big_off", 17301515); //
            put("btn_star_big_on", 17301516); //
            put("button_onoff_indicator_off", 17301518); //
            put("button_onoff_indicator_on", 17301517); //
            put("checkbox_off_background", 17301519); //
            put("checkbox_on_background", 17301520); //
            put("dark_header", 17301521); //
            put("dialog_frame", 17301521); //
            put("dialog_holo_dark_frame", 17301682); //
            put("dialog_holo_light_frame", 17301683); //
            put("divider_horizontal_bright", 17301522); //
            put("divider_horizontal_dark", 17301524); //
            put("divider_horizontal_dim_dark", 17301525); //
            put("divider_horizontal_textfield", 17301523); //
            put("edit_text", 17301526); //
            put("editbox_background", 17301528); //
            put("editbox_background_normal", 17301529); //
            put("editbox_dropdown_dark_frame", 17301530); //
            put("editbox_dropdown_light_frame", 17301531); //
            put("gallery_thumb", 17301532); //
            put("ic_btn_speak_now", 17301668); //
            put("ic_delete", 17301533); //
            put("ic_dialog_alert", 17301543); //
            put("ic_dialog_dialer", 17301544); //
            put("ic_dialog_email", 17301545); //
            put("ic_dialog_info", 17301659); //
            put("ic_dialog_map", 17301546); //
            put("ic_input_add", 17301547); //
            put("ic_input_delete", 17301548); //
            put("ic_input_get", 17301549); //
            put("ic_lock_idle_alarm", 17301550); //
            put("ic_lock_idle_charging", 17301534); //
            put("ic_lock_idle_lock", 17301535); //
            put("ic_lock_idle_low_battery", 17301536); //
            put("ic_lock_lock", 17301551); //
            put("ic_lock_power_off", 17301552); //
            put("ic_lock_silent_mode", 17301553); //
            put("ic_lock_silent_mode_off", 17301554); //
            put("ic_media_ff", 17301537); //
            put("ic_media_next", 17301538); //
            put("ic_media_pause", 17301539); //
            put("ic_media_play", 17301540); //
            put("ic_media_previous", 17301541); //
            put("ic_media_rew", 17301542); //
            put("ic_menu_add", 17301555); //
            put("ic_menu_agenda", 17301556); //
            put("ic_menu_always_landscape_portrait", 17301557); //
            put("ic_menu_call", 17301558); //
            put("ic_menu_camera", 17301559); //
            put("ic_menu_close_clear_cancel", 17301560); //
            put("ic_menu_compass", 17301561); //
            put("ic_menu_crop", 17301562); //
            put("ic_menu_day", 17301563); //
            put("ic_menu_delete", 17301564); //
            put("ic_menu_directions", 17301565); //
            put("ic_menu_edit", 17301566); //
            put("ic_menu_gallery", 17301567); //
            put("ic_menu_help", 17301568); //
            put("ic_menu_info_details", 17301569); //
            put("ic_menu_manage", 17301570); //
            put("ic_menu_mapmode", 17301571); //
            put("ic_menu_month", 17301572); //
            put("ic_menu_more", 17301573); //
            put("ic_menu_my_calendar", 17301574); //
            put("ic_menu_mylocation", 17301575); //
            put("ic_menu_myplaces", 17301576); //
            put("ic_menu_preferences", 17301577); //
            put("ic_menu_recent_history", 17301578); //
            put("ic_menu_report_image", 17301579); //
            put("ic_menu_revert", 17301580); //
            put("ic_menu_rotate", 17301581); //
            put("ic_menu_save", 17301582); //
            put("ic_menu_search", 17301583); //
            put("ic_menu_send", 17301584); //
            put("ic_menu_set_as", 17301585); //
            put("ic_menu_share", 17301586); //
            put("ic_menu_slideshow", 17301587); //
            put("ic_menu_sort_alphabetically", 17301660); //
            put("ic_menu_sort_by_size", 17301661); //
            put("ic_menu_today", 17301588); //
            put("ic_menu_upload", 17301589); //
            put("ic_menu_upload_you_tube", 17301590); //
            put("ic_menu_view", 17301591); //
            put("ic_menu_week", 17301592); //
            put("ic_menu_zoom", 17301593); //
            put("ic_notification_clear_all", 17301594); //
            put("ic_notification_overlay", 17301595); //
            put("ic_partial_secure", 17301596); //
            put("ic_popup_disk_full", 17301597); //
            put("ic_popup_reminder", 17301598); //
            put("ic_popup_sync", 17301599); //
            put("ic_search_category_default", 17301600); //
            put("ic_secure", 17301601); //
            put("list_selector_background", 17301602); //
            put("menu_frame", 17301603); //
            put("menu_full_frame", 17301604); //
            put("menuitem_background", 17301605); //
            put("picture_frame", 17301606); //
            put("presence_audio_away", 17301679); //
            put("presence_audio_busy", 17301680); //
            put("presence_audio_online", 17301681); //
            put("presence_away", 17301607); //
            put("presence_busy", 17301608); //
            put("presence_invisible", 17301609); //
            put("presence_offline", 17301610); //
            put("presence_online", 17301611); //
            put("presence_video_away", 17301676); //
            put("presence_video_busy", 17301677); //
            put("presence_video_online", 17301678); //
            put("progress_horizontal", 17301612); //
            put("progress_indeterminate_horizontal", 17301613); //
            put("radiobutton_off_background", 17301614); //
            put("radiobutton_on_background", 17301615); //
            put("screen_background_dark", 17301656); //
            put("screen_background_dark_transparent", 17301673); //
            put("screen_background_light", 17301657); //
            put("screen_background_light_transparent", 17301674); //
            put("spinner_background", 17301616); //
            put("spinner_dropdown_background", 17301617); //
            put("star_big_off", 17301619); //
            put("star_big_on", 17301621); //
            put("star_off", 17301618); //
            put("star_on", 17301620); //
            put("stat_notify_call_mute", 17301622); //
            put("stat_notify_chat", 17301623); //
            put("stat_notify_error", 17301624); //
            put("stat_notify_missed_call", 17301631); //
            put("stat_notify_more", 17301625); //
            put("stat_notify_sdcard", 17301626); //
            put("stat_notify_sdcard_prepare", 17301675); //
            put("stat_notify_sdcard_usb", 17301627); //
            put("stat_notify_sync", 17301628); //
            put("stat_notify_sync_noanim", 17301629); //
            put("stat_notify_voicemail", 17301630); //
            put("stat_sys_data_bluetooth", 17301632); //
            put("stat_sys_download", 17301633); //
            put("stat_sys_download_done", 17301634); //
            put("stat_sys_headset", 17301635); //
            put("stat_sys_phone_call", 17301636); //
            put("stat_sys_phone_call_forward", 17301637); //
            put("stat_sys_phone_call_on_hold", 17301638); //
            put("stat_sys_speakerphone", 17301639); //
            put("stat_sys_upload", 17301640); //
            put("stat_sys_upload_done", 17301641); //
            put("stat_sys_vp_phone_call", 17301671); //
            put("stat_sys_vp_phone_call_on_hold", 17301672); //
            put("stat_sys_warning", 17301642); //
            put("status_bar_item_app_background", 17301643); //
            put("status_bar_item_background", 17301644); //
            put("sym_action_call", 17301645); //
            put("sym_action_chat", 17301646); //
            put("sym_action_email", 17301647); //
            put("sym_call_incoming", 17301648); //
            put("sym_call_missed", 17301649); //
            put("sym_call_outgoing", 17301650); //
            put("sym_contact_card", 17301652); //
            put("sym_def_app_icon", 17301651); //
            put("title_bar", 17301653); //
            put("title_bar_tall", 17301670); //
            put("toast_frame", 17301654); //
            put("zoom_plate", 17301655); //
        }
    };

    static int getIcon(String iconName, Context thisContext) {
        iconName = iconName.trim();
        if (iconName.startsWith("android.R.drawable."))
            iconName = iconName.substring(19);
        if (iconName == "ic_launcher")
            return thisContext.getApplicationInfo().icon;

        Integer id = IconIds.get(iconName);
        if (id == null)
            return 0x1080095; // 17301653, title_bar dunkles Quadrat
        return id;
    }

    static boolean assetFileExists(Context context, String pathInAssetsDir) {
        if (pathInAssetsDir == null)
            return false;
        pathInAssetsDir = pathInAssetsDir.trim();
        if (pathInAssetsDir.isEmpty())
            return false;

        AssetManager assetManager = context.getAssets();
        InputStream inputStream = null;
        try {
            inputStream = assetManager.open(pathInAssetsDir);
            if (inputStream != null) {
                Log.d(LOG_TAG, "Asset file exists: " + pathInAssetsDir);
                return true;
            }
        } catch (IOException e) {
            Log.d(LOG_TAG, "Asset not existing: " + pathInAssetsDir);
        } finally {
            try {
                if (inputStream != null)
                    inputStream.close();
            } catch (IOException e) {
            }
        }
        return false;
    }

    static Bitmap getBitmap(Context context, String filePath) {
        Bitmap bitmap = null;
        if (filePath.contains("/sdcard/")) {
            File sd = Environment.getExternalStorageDirectory();
            filePath.replace("/sdcard/", (new StringBuilder()).append(sd).append("/").toString());
            File image = new File(filePath);
            bitmap = BitmapFactory.decodeFile(image.getAbsolutePath());
        } else {
            AssetManager assetManager = context.getAssets();
            try {
                java.io.InputStream istr = assetManager.open(filePath);
                bitmap = BitmapFactory.decodeStream(istr);
            } catch (IOException ioexception) {
            }
        }
        return bitmap;
    }

    static void createNotificationChannel(Context context, String channelID, String channelName,
            String channelDescription) {
        NotificationManager manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            NotificationChannel serviceChannel = new NotificationChannel(channelID, channelName,
                    NotificationManager.IMPORTANCE_MIN);
            manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
            manager.createNotificationChannel(serviceChannel);
        }
    }

    static Notification CerateNotification(Context context, String channelID, String title, String text,
            String smallIconPath, int notificationIcon, String className, String startValue) {

        Intent notificationIntent = null;
        PendingIntent pendingIntent = null;

        if (!className.isEmpty()) {
            try {
                Log.d(LOG_TAG, "Util, className: " + className);
                notificationIntent = new Intent(context, Class.forName(className));
            } catch (Exception e) {
                Log.d(LOG_TAG, "KeepAlive: Klasse nicht gefunden:" + className);
            }

            notificationIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK + Intent.FLAG_ACTIVITY_MULTIPLE_TASK
                    + Intent.FLAG_ACTIVITY_NO_ANIMATION);

            if (notificationIntent != null) {
                notificationIntent.putExtra("APP_INVENTOR_START", startValue);

                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M)
                    pendingIntent = PendingIntent.getActivity(context, 0, notificationIntent,
                            PendingIntent.FLAG_UPDATE_CURRENT | PendingIntent.FLAG_IMMUTABLE);
                else
                    pendingIntent = PendingIntent.getActivity(context, 0, notificationIntent, 0);
            }
        }

        Notification.Builder nb = new Notification.Builder(context, channelID);
        nb.setContentTitle(title);
        nb.setContentText(text);
        nb.setShowWhen(false);

        Icon icon = null;
        if (!smallIconPath.isEmpty()) {
            Bitmap iconBitmap = Util.getBitmap(context, smallIconPath);
            icon = icon.createWithBitmap(iconBitmap);
        }

        if (icon == null) {
            nb.setSmallIcon(notificationIcon);
        } else {
            nb.setSmallIcon(icon);
        }

        nb.setContentIntent(pendingIntent);
        return nb.build();
    }
}