package de.ullisroboterseite.urskeepalivemanifest;

// Autor: http://UllisRoboterSeite.de
// Doku:  http://UllisRoboterSeite.de/android-AI2-KeepAlive.html
// Created: 2021-03-16
//
// Version 1.0 (2021-03-16)
// -------------------------
// - Basis-Version
//

/* =============================================================
Hinweis:
--------------

Kodular kennt die "@UsesServices"-Annotation nicht. Man kann aber die .aix-Datei patchen.
In der erstellten .aix-Datei findet man im Verzeichnis "files" die Dateien
"component_build_info.json" und "component_build_infos.json". Dort sind die
u.a. die notwendigen Manifest-Einträge hinterlegt.
Wenn in beiden das Feld "broadcastReceivers" passend belegt wird, erstellt
auch Koludar das korrekte Manifest. So sieht das Feld aus:

"broadcastReceivers":["<service android:name=\"de.ullisroboterseite.ursai2keepalive.UrsService\" android:enabled=\"true\" android:exported=\"false\"/>"]


Alternativ kann man die Extension UrsKeepAliveManifest einbinden. Diese enthält
nur den oben beschriebenen Eintrag.
============================================================= */

import com.google.appinventor.components.annotations.*;
import com.google.appinventor.components.annotations.androidmanifest.*;
import com.google.appinventor.components.common.*;
import com.google.appinventor.components.runtime.*;
import com.google.appinventor.components.runtime.util.*;


@DesignerComponent(version = 1 //
        , versionName = UrsKeepAliveManifest.VersionName //
        , dateBuilt = UrsKeepAliveManifest.dateBuilt //
        , description = "Extension to add service to Kodular." //
        , category = com.google.appinventor.components.common.ComponentCategory.EXTENSION //
        , nonVisible = true //
        , helpUrl = "https://UllisRoboterSeite.de/android-AI2-KeepAlive.html" //
        , iconName = "aiwebres/icon.png")
@SimpleObject(external = true)
public class UrsKeepAliveManifest extends AndroidNonvisibleComponent {
    static final String LOG_TAG = "KEEPALIVE";
    static final String VersionName = "1.0.1";
    static final String dateBuilt = "2021-03-16";

    public UrsKeepAliveManifest(ComponentContainer container) {
        super(container.$form());
     }
}